
; *********************************************************************
; *                                                                   *
; *        BlitzBasic (2D-Version) Misc-Extractor (Engine) V1.3       *
; * ----------------------------------------------------------------- *
; *          Written in 2005 by Harald Wagner (AL90@Lycos.de)         *
; *                                                                   *
; *********************************************************************



; The Following Commands are like the Original Commands from BlitzBasic.
; The only difference is the Included Char "_" at the end of a Command.
; 
; For Example:
; ------------
;
; From "LoadImage(Params...)" to "LoadImage_(Params...)"
;
; So with underline ("_") at the end of BlitzBasic-Command.
; Parameters of the Replacement-Commands are the same how in BlitzBasic.
; Before you can use the Replacement-Commands, you must call
; at startup for one the "OpenArchiveFile()" Function, withit the
; Extractor can find the Used BCA-ArchiveFile (.BCA)
; You must call so the "OpenArchiveFile()"-Function only one before
; using the Replacement-Commands. So its only a single call at Program-
; Startup requiered to use the Replaced-Commands in your Programcode.
; If your Applikation is running stable, you can now create a Single-
; File with BBCruncher when its requiered.
;
; Supported Original BlitzCommands-List:
; --------------------------------------
;
; LoadAnimImage()
; LoadBuffer()
; LoadImage()
; LoadSound()
; OpenMovie()
; PlayMusic()
; ReadFile()
; CloseFile()


; Commands-List in Replacement Mode:
; ----------------------------------
;
; LoadAnimImage_()
; LoadBuffer_()
; LoadImage_()
; LoadSound_()
; OpenMovie_()
; PlayMusic_()
; ReadFile_()
; CloseFile_()


Global bcafile$

Function OpenArchiveFile(arc$)
bcafile$=arc$
End Function

Function ExtractTempFile$(bbc$)

Local fnsize,tst$,tst2$,noerror,pack$,media$,dest$,offset,offset1
Local offset2,offset3,verz$,pfad,file$,size,vers,anzfiles,bbcname$
Local pos,origsize,origoffset,destoffset,packs,blocksize,bnk1,bnk2,scan
Local origbnk,destbnk,blks,rest,loop,count,scanvalue,bytes,neu
Local einzelpeek,einzelpoke,einzelsumme,arc$,b,i,a,r,l,z

fnsize=0
b=Len(bbc$)
tst$="Important! - Do not change this Line, its used for SingleFile-Creation!"
arc$=bcafile$

;
; Puren FilenamePart ohne ":\" und "\" ermitteln.
;

For i=b To 1 Step -1
  If Mid$(bbc$,i,1)<>"/" And Mid$(bbc$,i,1)<>"\" And Mid$(bbc$,i,1)<>":" Then fnsize=fnsize+1
  If Mid$(bbc$,i,1)="/" Or Mid$(bbc$,i,1)="\" Or Mid$(bbc$,i,1)=":" Then Exit
Next

noerror=0
a=b-fnsize+1
pack$=Mid$(bbc$,a)
media$=pack$
b=Len(media$)-4
If Right$(media$,4)=".bbc" Then media$=Mid$(media$,1,b)
If Right$(pack$,4)=".bbc" Then noerror=1
If Right$(pack$,4)<>".bbc"Then pack$=pack$+".bbc"
dest$=SystemProperty$("tempdir")
If Right$(dest$,1)<>"\" Then dest$=dest$+"\"
dest$=dest$+media$
offset=0
offset1=tst$
offset2=Mid$(tst$,Instr(tst$,Chr$(32))+1)
offset3=Mid$(tst$,Len(Str$(offset1))+Len(Str$(offset2))+3)
If offset1<0 Then offset1=0
If offset2<0 Then offset2=0
If offset3<0 Then offset3=-1

;
; BCA aus EXE-File ermitteln.
;

If FileSize(arc$)=0
  arc$=""
  verz$=SystemProperty$("appdir")
  pfad=ReadDir(verz$)
  Repeat
    file$=NextFile$(pfad)
    If file$="" Then Exit
    If FileType(file$)=1
      If FileSize(file$)=offset3 And Lower$(Right$(file$,4))=".exe"
        size=FileSize(file$)
        r=ReadFile(file$)
        If r>0
          SeekFile(r,offset2)
          tst2$=""
          For i=1 To Len(tst$)
            b=ReadByte(r)
            tst2$=tst2$+Chr$(b)
          Next
          CloseFile(r)
        EndIf
        If tst$=tst2$
          offset=offset1
          arc$=file$
        EndIf
      EndIf
    EndIf
  Until offset>0
  CloseDir pfad
EndIf

If arc$=""
  RuntimeError ".BCA ArchiveFile not Found!"
  End
EndIf

r=ReadFile(arc$)
If offset>0 Then SeekFile(r,offset)
vers=ReadInt(r)

If vers<>$00414342 ; Not a Supported BCA-ArchiveFile
  CloseFile(r)
  RuntimeError "Not a Supported BCA-ArchiveFile!"
  End
EndIf

anzfiles=ReadInt(r)

For i=1 To anzfiles
  bbcname$=ReadString(r)
  l=ReadInt(r)
  If Lower$(bbcname$)=Lower$(pack$) Then Exit
  pos=FilePos(r)+l
  SeekFile(r,pos)
Next

If Lower$(bbcname$)<>Lower$(pack$)
  CloseFile(r)
  If noerror=0
    RuntimeError pack$+" not found in BCA-ArchiveFile!"
    End
  Else
    Return ""
  EndIf
EndIf

vers=ReadInt(r)
l=l-9:origsize=l
origoffset=0
destoffset=0
packs=ReadByte(r)
blocksize=ReadInt(r)
bnk1=CreateBank(blocksize+1)
bnk2=CreateBank(blocksize+1)
scan=CreateBank(128)
origbnk=CreateBank(l+10000)
destbnk=CreateBank(l+10000)
ReadBytes(origbnk,r,0,l) ; Load PakedFile into MEMORY!
CloseFile(r)
blks=l/blocksize:rest=l-(blks*blocksize):z=0

Repeat

  z=z+1
  origoffset=0
  destoffset=0
  l=PeekInt(origbnk,0)
  If l>BankSize(origbnk) Then ResizeBank origbnk,l+10000
  If l>BankSize(destbnk) Then ResizeBank destbnk,l+10000
  origoffset=origoffset+4
  blks=l/blocksize:rest=l-(blks*blocksize)

  ;
  ; Datei entpacken.
  ;

  For loop=1 To blks
    count=0:pos=0
    scanvalue=PeekByte(origbnk,origoffset)
    origoffset=origoffset+1

    If scanvalue=0
       CopyBank origbnk,origoffset,bnk1,1,blocksize
       origoffset=origoffset+blocksize
       CopyBank bnk1,1,destbnk,destoffset,blocksize
       destoffset=destoffset+blocksize
    EndIf

    If scanvalue<>0
      bytes=PeekByte(origbnk,origoffset)
      origoffset=origoffset+1
      CopyBank(origbnk,origoffset,scan,1,bytes)
      origoffset=origoffset+bytes

      Repeat
        b=PeekByte(origbnk,origoffset)
        origoffset=origoffset+1

        If b=scanvalue
          If einzelsumme>0
            CopyBank(origbnk,einzelpeek,bnk2,einzelpoke,einzelsumme)
            einzelsumme=0
          EndIf
          CopyBank scan,1,bnk2,pos+1,bytes
          count=count+bytes
          pos=pos+bytes
          If count=>blocksize Then Exit
        Else
          count=count+1
          pos=pos+1
          If einzelsumme=0:einzelpoke=pos:einzelpeek=origoffset-1:EndIf
          einzelsumme=einzelsumme+1
          If count=>blocksize Then Exit
        EndIf

      Until count=>blocksize

      If einzelsumme>0
        CopyBank(origbnk,einzelpeek,bnk2,einzelpoke,einzelsumme)
        einzelsumme=0
      EndIf

      CopyBank bnk2,1,destbnk,destoffset,pos
      destoffset=destoffset+pos
    EndIf
  Next

  If rest>0
    CopyBank origbnk,origoffset,destbnk,destoffset,rest
    origoffset=origoffset+rest
    destoffset=destoffset+rest
  EndIf

  CopyBank destbnk,0,origbnk,0,destoffset
  origsize=destoffset

Until z=packs

neu=WriteFile(dest$)
WriteBytes(destbnk,neu,0,origsize)
CloseFile(neu)
FreeBank bnk1
FreeBank bnk2
FreeBank scan
FreeBank origbnk
FreeBank destbnk
Return dest$
End Function

Function LoadAnimImage_(z$,x,y,s,f)
Local t$,b
t$=ExtractTempFile$(z$)
b=LoadAnimImage(t$,x,y,s,f)
DeleteFile t$
Return b
End Function

Function LoadBuffer_(b,z$)
Local t$,a
t$=ExtractTempFile$(z$)
a=LoadBuffer(b,t$)
DeleteFile t$
Return a
End Function

Function LoadImage_(z$)
Local t$,b
t$=ExtractTempFile$(z$)
b=LoadImage(t$)
DeleteFile t$
Return b
End Function

Function LoadSound_(z$)
Local t$,a
t$=ExtractTempFile$(z$)
a=LoadSound(t$)
DeleteFile t$
Return a
End Function

Function OpenMovie_(z$)
Local t$,a
t$=ExtractTempFile$(z$)
a=OpenMovie(t$)
DeleteFile t$
Return a
End Function

Function PlayMusic_(z$)
Local t$,b
t$=ExtractTempFile$(z$)
b=PlayMusic(t$)
Return b
End Function

Function ReadFile_(z$)
Local t$,d$,a,w
d$=SystemProperty$("tempdir")
If Right$(d$,1)<>"\" Then d$=d$+"\"
If Not FileSize(z$)
  t$=ExtractTempFile$(z$)
  a=ReadFile(t$)
  d$=d$+Str(a)
  w=WriteFile(d$)
  WriteString w,t$
  CloseFile(w)
Else
  a=ReadFile(z$)
EndIf
Return a
End Function

Function CloseFile_(a)
Local b$,d$,r
d$=SystemProperty$("tempdir")
If Right$(d$,1)<>"\" Then d$=d$+"\"
d$=d$+Str(a)
CloseFile(a)
r=ReadFile(d$)
If r>0
  b$=ReadString(r)
  CloseFile(r)
  DeleteFile b$
  DeleteFile d$
EndIf
End Function
