
' **************************************************************
' *                                                            *
' *     BlitzMax File-Cruncher (Engine) V2.1 (File-Packer)     *
' * ---------------------------------------------------------- *
' *      Written in 2005 by Harald Wagner (AL90@Lycos.de)      *
' *                                                            *
' **************************************************************



Function Crunch(source$,dest$,packrate)

'
' Initialisierung.
'

Local founds2:Short[65536];Local founds:Byte[257]
Local scanvals4[1021];Local oldoffset4[1021];Local founds4:Short[1021]
Local scanvals8[2041,2];Local oldoffset8[2041];Local founds8:Short[2041]
Local scanvals16[4081,4];Local oldoffset16[4081];Local founds16:Short[4081]
Local scanvals32[8161,8];Local oldoffset32[8161];Local founds32:Short[8161]
Local packs,blocksize,origoffset,orig,neu,origsize,blocks
Local rest,destoffset,loop,scanvalue,wert,bytes,lowest,packsize
Local summe,langword1,langword2,langword3,langword4,langword5
Local langword6,langword7,langword8,tst,word,bits,count,pos,result
Local crunchout,chksum,a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q:Short,v,w,x,y,z
Local a1,b1,c1,d1,e1,f1,g1,h1,i1,j1,k1,l1,m1,n1,o1,p1,v1,v2,w1,w2
Local nextcheck,bbctest,u#,t#,gain#,processbar#

If packrate<1 Then packrate=1
If packrate>4 Then packrate=4
If packrate=1 Then processbar#=100
If packrate=2 Then processbar#=298.0/10
If packrate=3 Then processbar#=298.0/30
If packrate=4 Then processbar#=298.0/60

If Lower$(Right$(dest$,4))<>".bbc" Then dest$=dest$+".bbc"
packs=0
blocksize=2600
origoffset=0
l=FileSize(source$)
origsize=l
If l<blocksize And l>99 Then blocksize=100

' Destination File schon bereits gepackt?

If FileSize(source$)>3
  l=FileSize(source$)
  orig=ReadFile(source$)
  bbctest=Readint(orig)
  CloseFile(orig)
  If bbctest=$00434242
    orig=ReadFile(source$)
    neu=WriteFile(dest$)
    Local bnk3:TBank=CreateBank(l+1000)
    bnk3.Read(orig,0,l)
    bnk3.Write(neu,0,l)
    CloseFile(orig)
    CloseFile(neu)
    bnk3=Null
    FlushMem
    Return 0
  EndIf
EndIf

' Destination File Storen weil offset so gewhlt oder File zu klein ist.

If l<100 Or packrate=1
  orig=ReadFile(source$)
  neu=WriteFile(dest$)
  WriteInt neu,$00434242
  WriteByte neu,1  ' Packs auf "1"
  WriteInt neu,l   ' Angepasste Blocksize
  WriteInt neu,l   ' Unpacklen
  WriteByte neu,0  ' Ungepackt Speichern
  Local bnk4:TBank=CreateBank(l+1000)
  bnk4.Read(orig,0,l)
  bnk4.Write(neu,0,l)
  CloseFile(orig)
  CloseFile(neu)
  bnk4=Null
  FlushMem
  Return 0
EndIf

Local bnk1:TBank=CreateBank(blocksize+3)
Local bnk2:TBank=CreateBank(blocksize+3)
Local scan:TBank=CreateBank(127+1) ' max. bis 127
Local origbnk:TBank=CreateBank(l+100000)
Local destbnk:TBank=CreateBank(l+100000)

' Load the OrigFile into MEMORY!

orig=ReadFile(source$)
origbnk.Read(orig,0,l)
CloseFile(orig)

'
' CrunchProzess starten.
'

Repeat ' Packschleife

  packs=packs+1
  l=origsize
  origoffset=0
  destoffset=4
  destbnk.PokeInt 0,l
  blocks=l/blocksize;rest=l-(blocks*blocksize)

  For loop=1 To blocks

    CopyBank origbnk:TBank,origoffset,bnk1:TBank,1,blocksize
    origoffset=origoffset+blocksize

    '
    ' Scanvalue fr aktuellen Block suchen. ($01 - $FF) (Blocksize = 2600 Bytes)
    '

    scanvalue=256

    MemClear(Byte Ptr(founds),256)
    For q=1 To blocksize
      wert=bnk1.PeekByte(q)
      If founds[wert]=0 Then founds[wert]=1
    Next
    For i=1 To 256
      If founds[i]=0 Then scanvalue=i;Exit
    Next

    '
    ' Hufigst vorkommenden gleichwertigen Bytes suchen. (z.B. $FCE2)
    '

    lowest=blocksize;nextcheck=0
    bytes=0   ' Bleibt "0" wenn packen des Blocks nicht mehr mglich ist!

    If scanvalue<256

      If packs>14
        packsize=blocksize;summe=0
        MemClear(Byte Ptr(founds2),65536*2)
        For z=1 To blocksize
          bits=bnk1.PeekShort(z)
          founds2[bits]=founds2[bits]+1
          If founds2[bits]>summe Then summe=founds2[bits];word=bits
          If bnk1.PeekShort(z+1)=bits Then z=z+1
        Next
        If summe>2
          packsize=packsize-(summe*2)+summe
          packsize=packsize+2+2
          If packsize=<lowest
            lowest=packsize
            bytes=2
            nextcheck=1
            scan.PokeShort 1,word
          EndIf
        EndIf
      Else
        nextcheck=1
      EndIf

      If nextcheck=1 And packs<15
        packsize=blocksize;summe=0;nextcheck=0
        MemClear(Byte Ptr(founds4),1021*2)
        MemClear(Byte Ptr(scanvals4),1021*4)
        MemClear(Byte Ptr(oldoffset4),1021*4)
        For z=1 To blocksize-3
          a=bnk1.PeekByte(z+0);b=bnk1.PeekByte(z+1)
          c=bnk1.PeekByte(z+2);d=bnk1.PeekByte(z+3)
          x=bnk1.PeekInt(z+0)
          tst=0
          chksum=a+b+c+d
          If scanvals4[chksum]=x Then If z>oldoffset4[chksum]+3 Then tst=1
          If scanvals4[chksum]=0 Then If founds4[chksum]=0 Then tst=1
          If tst=1
            founds4[chksum]=founds4[chksum]+1
            scanvals4[chksum]=x;oldoffset4[chksum]=z
            If founds4[chksum]>summe Then summe=founds4[chksum];bits=z
          EndIf
        Next
        If summe>1
          packsize=packsize-(summe*4)+summe
          packsize=packsize+2+4
          If packsize=<lowest
            lowest=packsize
            bytes=4
            nextcheck=1
            langword1=bnk1.PeekInt(bits)
            scan.PokeInt 1,langword1
          EndIf
        EndIf
      EndIf

      If nextcheck=1 And packs<14
        packsize=blocksize;summe=0;nextcheck=0
        MemClear(Byte Ptr(founds8),2041*2)
        MemClear(Byte Ptr(scanvals8),2041*8)
        MemClear(Byte Ptr(oldoffset8),2041*4)
        For z=1 To blocksize-7
          a=bnk1.PeekByte(z+0);b=bnk1.PeekByte(z+1)
          c=bnk1.PeekByte(z+2);d=bnk1.PeekByte(z+3)
          e=bnk1.PeekByte(z+4);f=bnk1.PeekByte(z+5)
          g=bnk1.PeekByte(z+6);h=bnk1.PeekByte(z+7)
          x=bnk1.PeekInt(z+0);y=bnk1.PeekInt(z+4)
          tst=0
          chksum=a+b+c+d+e+f+g+h
          If scanvals8[chksum,0]=x Then If scanvals8[chksum,1]=y Then If z>oldoffset8[chksum]+7 Then tst=1
          If scanvals8[chksum,0]=0 Then If scanvals8[chksum,1]=0 Then If founds8[chksum]=0 Then tst=1
          If tst=1
            founds8[chksum]=founds8[chksum]+1
            scanvals8[chksum,0]=x;scanvals8[chksum,1]=y;oldoffset8[chksum]=z
            If founds8[chksum]>summe Then summe=founds8[chksum];bits=z
          EndIf
        Next
        If summe>1
          packsize=packsize-(summe*8)+summe
          packsize=packsize+2+8
          If packsize=<lowest
            lowest=packsize
            bytes=8
            nextcheck=1
            langword1=bnk1.PeekInt(bits+0)
            langword2=bnk1.PeekInt(bits+4)
            scan.PokeInt 1,langword1
            scan.PokeInt 5,langword2
          EndIf
        EndIf
      EndIf

      If nextcheck=1 And packs<15
        packsize=blocksize;summe=0;nextcheck=0
        MemClear(Byte Ptr(founds16),4081*2)
        MemClear(Byte Ptr(scanvals16),4081*16)
        MemClear(Byte Ptr(oldoffset16),4081*4)
        For z=1 To blocksize-15
          a=bnk1.PeekByte(z+0);b=bnk1.PeekByte(z+1)
          c=bnk1.PeekByte(z+2);d=bnk1.PeekByte(z+3)
          e=bnk1.PeekByte(z+4);f=bnk1.PeekByte(z+5)
          g=bnk1.PeekByte(z+6);h=bnk1.PeekByte(z+7)
          i=bnk1.PeekByte(z+8);j=bnk1.PeekByte(z+9)
          k=bnk1.PeekByte(z+10);l=bnk1.PeekByte(z+11)
          m=bnk1.PeekByte(z+12);n=bnk1.PeekByte(z+13)
          o=bnk1.PeekByte(z+14);p=bnk1.PeekByte(z+15)
          x=bnk1.PeekInt(z+0);y=bnk1.PeekInt(z+4)
          v=bnk1.PeekInt(z+8);w=bnk1.PeekInt(z+12)
          tst=0
          chksum=a+b+c+d+e+f+g+h+i+j+k+l+m+n+o+p
          If scanvals16[chksum,0]=x Then If scanvals16[chksum,1]=y Then If scanvals16[chksum,2]=v Then If scanvals16[chksum,3]=w Then If z>oldoffset16[chksum]+15 Then tst=1
          If scanvals16[chksum,0]=0 Then If scanvals16[chksum,1]=0 Then If scanvals16[chksum,2]=0 Then If scanvals16[chksum,3]=0 Then If founds16[chksum]=0 Then tst=1
          If tst=1
            founds16[chksum]=founds16[chksum]+1
            scanvals16[chksum,0]=x;scanvals16[chksum,1]=y;scanvals16[chksum,2]=v;scanvals16[chksum,3]=w;oldoffset16[chksum]=z
            If founds16[chksum]>summe Then summe=founds16[chksum];bits=z
          EndIf
        Next
        If summe>1
          packsize=packsize-(summe*16)+summe
          packsize=packsize+2+16
          If packsize=<lowest
            lowest=packsize
            bytes=16
            nextcheck=1
            langword1=bnk1.PeekInt(bits+0)
            langword2=bnk1.PeekInt(bits+4)
            langword3=bnk1.PeekInt(bits+8)
            langword4=bnk1.PeekInt(bits+12)
            scan.PokeInt 1,langword1
            scan.PokeInt 5,langword2
            scan.PokeInt 9,langword3
            scan.PokeInt 13,langword4
          EndIf
        EndIf
      EndIf

      If nextcheck=1 And packs<4
        packsize=blocksize;summe=0;nextcheck=0
        MemClear(Byte Ptr(founds32),8161*2)
        MemClear(Byte Ptr(scanvals32),8161*32)
        MemClear(Byte Ptr(oldoffset32),8161*4)
        For z=1 To blocksize-31
          a=bnk1.PeekByte(z+0);b=bnk1.PeekByte(z+1)
          c=bnk1.PeekByte(z+2);d=bnk1.PeekByte(z+3)
          e=bnk1.PeekByte(z+4);f=bnk1.PeekByte(z+5)
          g=bnk1.PeekByte(z+6);h=bnk1.PeekByte(z+7)
          i=bnk1.PeekByte(z+8);j=bnk1.PeekByte(z+9)
          k=bnk1.PeekByte(z+10);l=bnk1.PeekByte(z+11)
          m=bnk1.PeekByte(z+12);n=bnk1.PeekByte(z+13)
          o=bnk1.PeekByte(z+14);p=bnk1.PeekByte(z+15)
          a1=bnk1.PeekByte(z+16);b1=bnk1.PeekByte(z+17)
          c1=bnk1.PeekByte(z+18);d1=bnk1.PeekByte(z+19)
          e1=bnk1.PeekByte(z+20);f1=bnk1.PeekByte(z+21)
          g1=bnk1.PeekByte(z+22);h1=bnk1.PeekByte(z+23)
          i1=bnk1.PeekByte(z+24);j1=bnk1.PeekByte(z+25)
          k1=bnk1.PeekByte(z+26);l1=bnk1.PeekByte(z+27)
          m1=bnk1.PeekByte(z+28);n1=bnk1.PeekByte(z+29)
          o1=bnk1.PeekByte(z+30);p1=bnk1.PeekByte(z+31)
          x=bnk1.PeekInt(z+0);y=bnk1.PeekInt(z+4)
          v=bnk1.PeekInt(z+8);w=bnk1.PeekInt(z+12)
          v1=bnk1.PeekInt(z+16);w1=bnk1.PeekInt(z+20)
          v2=bnk1.PeekInt(z+24);w2=bnk1.PeekInt(z+28)
          tst=0
          chksum=a+b+c+d+e+f+g+h+i+j+k+l+m+n+o+p+a1+b1+c1+d1+e1+f1+g1+h1+i1+j1+k1+l1+m1+n1+o1+p1
          If scanvals32[chksum,0]=x Then If scanvals32[chksum,1]=y Then If scanvals32[chksum,2]=v Then If scanvals32[chksum,3]=w
            If scanvals32[chksum,4]=v1 Then If scanvals32[chksum,5]=w1 Then If scanvals32[chksum,6]=v2 Then If scanvals32[chksum,7]=w2
              If z>oldoffset32[chksum]+31 Then tst=1
            EndIf
          EndIf
          If scanvals32[chksum,0]=0 Then If scanvals32[chksum,1]=0 Then If scanvals32[chksum,2]=0 Then If scanvals32[chksum,3]=0
            If scanvals32[chksum,4]=0 Then If scanvals32[chksum,5]=0 Then If scanvals32[chksum,6]=0 Then If scanvals32[chksum,7]=0
              If founds32[chksum]=0 Then tst=1
            EndIf
          EndIf
          If tst=1
            founds32[chksum]=founds32[chksum]+1;oldoffset32[chksum]=z
            scanvals32[chksum,0]=x;scanvals32[chksum,1]=y;scanvals32[chksum,2]=v;scanvals32[chksum,3]=w
            scanvals32[chksum,4]=v1;scanvals32[chksum,5]=w1;scanvals32[chksum,6]=v2;scanvals32[chksum,7]=w2
            If founds32[chksum]>summe Then summe=founds32[chksum];bits=z
          EndIf
        Next
        If summe>1
          packsize=packsize-(summe*32)+summe
          packsize=packsize+2+32
          If packsize=<lowest
            lowest=packsize
            bytes=32
            nextcheck=1
            langword1=bnk1.PeekInt(bits+0)
            langword2=bnk1.PeekInt(bits+4)
            langword3=bnk1.PeekInt(bits+8)
            langword4=bnk1.PeekInt(bits+12)
            langword5=bnk1.PeekInt(bits+16)
            langword6=bnk1.PeekInt(bits+20)
            langword7=bnk1.PeekInt(bits+24)
            langword8=bnk1.PeekInt(bits+28)
            scan.PokeInt 1,langword1
            scan.PokeInt 5,langword2
            scan.PokeInt 9,langword3
            scan.PokeInt 13,langword4
            scan.PokeInt 17,langword5
            scan.PokeInt 21,langword6
            scan.PokeInt 25,langword7
            scan.PokeInt 29,langword8
          EndIf
        EndIf
      EndIf

    EndIf

    '
    ' Mit dem Packen beginnen... (...wenn Packen des Blocks mglich ist)
    '

    If bytes>0
      pos=0
      For i=1 To blocksize
        result=0
' ------------------------------------------------------------------------
        If i=<blocksize-bytes+1 ' Falls Pack-Schleifen noch mglich sind
          If bnk1.PeekShort(i)=scan.PeekShort(1)
            If bytes=2  ' CompareMemory durchfhren!
              result=1
            Else
              result=1
              For z=0 To bytes-1 Step 4
                a=bnk1.PeekInt(i+z)
                b=scan.PeekInt(z+1)
                If a<>b Then result=0;Exit
              Next
            EndIf
            If result '                Schleife wird gepackt
              i=i+bytes-1;pos=pos+1
              bnk2.PokeByte pos,scanvalue
            EndIf
          EndIf
        EndIf
' ------------------------------------------------------------------------
        If result=0       ' keine schleife, nur 1 Byte decrunchen
          pos=pos+1
          bnk2.PokeByte pos,bnk1.PeekByte(i)
        EndIf
' ------------------------------------------------------------------------
      Next

      destbnk.PokeByte destoffset,scanvalue
      destoffset=destoffset+1
      destbnk.PokeByte destoffset,bytes
      destoffset=destoffset+1
      CopyBank scan:TBank,1,destbnk:TBank,destoffset,bytes
      destoffset=destoffset+bytes
      CopyBank bnk2:TBank,1,destbnk:TBank,destoffset,pos ' Gepackten Block Speichern!
      destoffset=destoffset+pos
    EndIf

    If bytes=0
      destbnk.PokeByte destoffset,0
      destoffset=destoffset+1
      CopyBank bnk1:TBank,1,destbnk:TBank,destoffset,blocksize ' Ungepackten Block Speichern!
      destoffset=destoffset+blocksize
    EndIf

  Next

  If rest>0
    CopyBank origbnk:TBank,origoffset,destbnk:TBank,destoffset,rest
    destoffset=destoffset+rest
  EndIf

  CopyBank destbnk:TBank,0,origbnk:TBank,0,destoffset
  x=origsize
  y=destoffset
  origsize=destoffset
  If y>x Or y<blocksize Then Exit
  u#=100;u#=u#/x;u#=u#*y;gain#=100-u#
  If packrate=2 And gain#<10 Then crunchout=crunchout+1;t#=t#+processbar#
  If packrate=3 And gain#<10 Then crunchout=crunchout+1;t#=t#+processbar#
  If packrate=4 And gain#<10 Then crunchout=crunchout+1;t#=t#+processbar#
  If packrate=2 And crunchout=10 Then Exit
  If packrate=3 And crunchout=30 Then Exit
  If packrate=4 And crunchout=60 Then Exit

Until packs=255

neu=WriteFile(dest$)
WriteInt neu,$00434242
WriteByte neu,packs
WriteInt neu,blocksize
origbnk.Write(neu,0,origsize)
CloseFile(neu)
bnk1=Null
bnk2=Null
scan=Null
origbnk=Null
destbnk=Null
FlushMem
x=FileSize(source$)
y=FileSize(dest$)
u#=100
u#=u#/x
u#=u#*y
t#=100-u#
p=Int(t#)

Return p

End Function
