
; ******************************************************************
; *                                                                *
; * BlitzPlus File-Extractor (Engine) V1.4 (For Bank Holding only) *
; * -------------------------------------------------------------- *
; *     Written in 2003 - 2005 by Harald Wagner (AL90@Lycos.de)    *
; *                                                                *
; ******************************************************************
;
;
;  Example1:  (With ProcessBar)
;  ----------------------------
;
;  adr=ExtractFile("C:\MyArchive.bca","MyFile_In_Archive.bbc")
;  Print "Unpacked Length is: "+BankSize(adr)
;
;
;  Example2:  (Without ProcessBar)
;  -------------------------------
;
;  adr=ExtractFile("C:\MyArchive.bca","MyFile_In_Archive.bbc",0)
;  Print "Unpacked Length is: "+BankSize(adr)


Function ExtractFile(arc$,pack$,xx=1)

tst$="Important! - Do not change this Line, its used for SingleFile-Creation!"
offset=0
offset1=tst$
offset2=Mid$(tst$,Instr(tst$,Chr$(32))+1)
If offset1<0 Then offset1=0
If offset2<0 Then offset2=0

If FileType(arc$)=0 ; Archive Existiert nicht - .BCA aus EXE-File ermitteln.
  arc$=""
  verz$=SystemProperty$("appdir")
  pfad=ReadDir(verz$)
  Repeat
    file$=NextFile$(pfad)
    If file$="" Then Exit
    If FileType(file$)=1
      If FileSize(file$)>offset1 And Lower$(Right$(file$,4))=".exe"
        size=FileSize(file$)
        r=ReadFile(file$)
        SeekFile(r,offset2)
        tst2$=""
        For i=1 To Len(tst$)
          b=ReadByte(r)
          tst2$=tst2$+Chr$(b)
        Next
        CloseFile(r)
        If tst$=tst2$
          offset=offset1
          arc$=file$
        EndIf
      EndIf
    EndIf
  Until offset>0
  CloseDir pfad
EndIf

If arc$=""
  RuntimeError ".BCA ArchiveFile not Found!"
  End
EndIf

r=ReadFile(arc$)
If offset>0 Then SeekFile(r,offset)
vers=ReadInt(r)

If vers<>$00414342 ; Not a Supported BCA-ArchiveFile
  CloseFile(r)
  Return -1
EndIf

anzfiles=ReadInt(r)

For i=1 To anzfiles
  bbcname$=ReadString(r)
  l=ReadInt(r)
  If Lower$(bbcname$)=Lower$(pack$) Then Exit
  pos=FilePos(r)+l
  SeekFile(r,pos)
Next

If Lower$(bbcname$)<>Lower$(pack$)
  CloseFile(r)
  Return -1
EndIf

vers=ReadInt(r)
l=l-9:origsize=l
origoffset=0
destoffset=0
packs=ReadByte(r)
blocksize=ReadInt(r)

If xx=1
  processbar#=1.0/packs
  b=ClientWidth(Desktop())
  h=ClientHeight(Desktop())
  window=CreateWindow("DeCrunching File...",(b/2)-160,(h/2)-60,320,120,0,1)
  progbar=CreateProgBar(20,30,270,23,window)
EndIf

bnk1=CreateBank(blocksize+1)
bnk2=CreateBank(blocksize+1)
scan=CreateBank(128)
origbnk=CreateBank(l+10000)
destbnk=CreateBank(l+10000)
ReadBytes(origbnk,r,0,l) ; Load PakedFile into MEMORY!
CloseFile(r)
blocks=l/blocksize:rest=l-(blocks*blocksize):z=0

Repeat
  z=z+1
  origoffset=0
  destoffset=0
  l=PeekInt(origbnk,0)
  If l>BankSize(origbnk) Then ResizeBank origbnk,l+10000
  If l>BankSize(destbnk) Then ResizeBank destbnk,l+10000
  origoffset=origoffset+4
  blocks=l/blocksize:rest=l-(blocks*blocksize)

  ;
  ; Datei entpacken.
  ;

  For loop=1 To blocks
    count=0:pos=0
    scanvalue=PeekByte(origbnk,origoffset)
    origoffset=origoffset+1

    If scanvalue=0
       CopyBank origbnk,origoffset,bnk1,1,blocksize
       origoffset=origoffset+blocksize
       CopyBank bnk1,1,destbnk,destoffset,blocksize
       destoffset=destoffset+blocksize
    EndIf

    If scanvalue<>0
      bytes=PeekByte(origbnk,origoffset)
      origoffset=origoffset+1
      CopyBank(origbnk,origoffset,scan,1,bytes)
      origoffset=origoffset+bytes

      Repeat
        b=PeekByte(origbnk,origoffset)
        origoffset=origoffset+1

        If b=scanvalue
          If einzelsumme>0
            CopyBank(origbnk,einzelpeek,bnk2,einzelpoke,einzelsumme)
            einzelsumme=0
          EndIf
          CopyBank scan,1,bnk2,pos+1,bytes
          count=count+bytes
          pos=pos+bytes
          If count=>blocksize Then Exit
        Else
          count=count+1
          pos=pos+1
          If einzelsumme=0:einzelpoke=pos:einzelpeek=origoffset-1:EndIf
          einzelsumme=einzelsumme+1
          If count=>blocksize Then Exit
        EndIf

      Until count=>blocksize

      If einzelsumme>0
        CopyBank(origbnk,einzelpeek,bnk2,einzelpoke,einzelsumme)
        einzelsumme=0
      EndIf

      CopyBank bnk2,1,destbnk,destoffset,pos
      destoffset=destoffset+pos
    EndIf
  Next

  If rest>0
    CopyBank origbnk,origoffset,destbnk,destoffset,rest
    origoffset=origoffset+rest
    destoffset=destoffset+rest
  EndIf

  CopyBank destbnk,0,origbnk,0,destoffset
  origsize=destoffset

  t#=t#+processbar#
  If xx=1 Then UpdateProgBar progbar,t#

Until z=packs

If xx=1
  UpdateProgBar progbar,1
  Notify "DeCrunchProcess Complete!"
  FreeGadget window
EndIf

FreeBank bnk1
FreeBank bnk2
FreeBank scan
FreeBank origbnk
ResizeBank destbnk,origsize
Return destbnk
End Function
