
; ******************************************************************
; *                                                                *
; *       PureBasic File-Cruncher (Engine) V2.1 (File-Packer)      *
; * -------------------------------------------------------------- *
; *      Written in 2003-2006 by Harald Wagner (AL90@Lycos.de)     *
; *                                                                *
; ******************************************************************



Procedure.l Crunch(source$,dest$,packrate,gui)

;
; Initialisierung.
;

If packrate<1:packrate=1:EndIf
If packrate>4:packrate=4:EndIf
If packrate=1:processbar=100:EndIf
If packrate=2:processbar=10:EndIf
If packrate=3:processbar=30:EndIf
If packrate=4:processbar=60:EndIf

If gui=1
  win=OpenWindow(1,227,113,352,127,"Crunching File...Please Wait!",#PB_Window_ScreenCentered) And CreateGadgetList(WindowID(1))
  ProgressBarGadget(1,40,40,270,30,0,processbar,#PB_ProgressBar_Smooth)
  SetGadgetState(1,1):SetGadgetState(1,0)
EndIf

Global Dim founds2.w(65535):Global Dim founds.w(256)
Global Dim scanvals4(1020):Global Dim oldoffset4.w(1020):Global Dim founds4.w(1020)
Global Dim scanvals8(2040,1):Global Dim oldoffset8.w(2040):Global Dim founds8.w(2040)
Global Dim scanvals16(4080,3):Global Dim oldoffset16.w(4080):Global Dim founds16.w(4080)
Global Dim scanvals32(8160,7):Global Dim oldoffset32.w(8160):Global Dim founds32.w(8160)

If LCase(Right(dest$,4))<>".bbc":dest$=dest$+".bbc":EndIf
packs=0
blocksize=2600
origoffset=0
l=FileSize(source$)
origsize=l
If l<blocksize And l>99:blocksize=100:EndIf

; Destination File schon bereits gepackt?

If FileSize(source$)>3
  orig=ReadFile(1,source$)
  bbctest=ReadLong(1)
  CloseFile(1)
  If bbctest=$00434242
    If gui=1
      While WindowEvent():Wend
      SetGadgetState(1,processbar)
    EndIf
    CopyFile(source$,dest$)
    If gui=1
      MessageRequester("Info", "Crunch Process Complete! - Gain: 0%"+Chr(10)+"",#MB_OK|#MB_ICONINFORMATION)
      CloseWindow(1)
    EndIf
    ProcedureReturn 0
  EndIf
EndIf

; Destination File Storen weil offset so gewhlt oder File zu klein ist.

If l<100 Or packrate=1
  If gui=1
    While WindowEvent():Wend
    SetGadgetState(1,processbar)
  EndIf
  orig=ReadFile(1,source$)
  neu=CreateFile(2,dest$)
  WriteLong(2,$00434242)
  WriteByte(2,1)  ; Packs auf "1"
  WriteLong(2,l)  ; Angepasste Blocksize
  WriteLong(2,l)  ; Unpacklen
  WriteByte(2,0)  ; Ungepackt Speichern
  bnk1=AllocateMemory(l+1000)
  ReadData(1,bnk1,l)
  WriteData(2,bnk1,l)
  CloseFile(1)
  CloseFile(2)
  FreeMemory(bnk1)
  If gui=1
    MessageRequester("Info", "Crunch Process Complete! - Gain: 0%"+Chr(10)+"",#MB_OK|#MB_ICONINFORMATION)
    CloseWindow(1)
  EndIf
  ProcedureReturn 0
EndIf

bnk1=AllocateMemory(blocksize+3)
bnk2=AllocateMemory(blocksize+3)
scan=AllocateMemory(127+1) ; max. bis 127
destbnk=AllocateMemory(l+100000)
origbnk=AllocateMemory(l+100000)

; Load the OrigFile into MEMORY!

orig=ReadFile(1,source$)
ReadData(1,origbnk,l)
CloseFile(1)

;
; CrunchProzess starten.
;

Repeat ; Packschleife

  packs+1
  l=origsize
  origoffset=0
  destoffset=4
  PokeL(destbnk,l)
  blocks=l/blocksize:rest=l-(blocks*blocksize)

  For loop=1 To blocks

    CopyMemory(origbnk+origoffset,bnk1+1,blocksize)
    origoffset=origoffset+blocksize

    ;
    ; Scanvalue fr aktuellen Block suchen. ($01 - $FF) (Blocksize = 2600 Bytes)
    ;

    scanvalue.w=256

    Global Dim founds.w(256)
    For q.w=1 To blocksize
      wert=PeekB(bnk1+q.w) & $FF
      If founds.w(wert)=0:founds.w(wert)=1:EndIf
    Next
    For i=1 To 256
      If founds.w(i)=0:scanvalue.w=i:Break:EndIf
    Next

    ;
    ; Hufigst vorkommenden gleichwertigen Bytes suchen. (z.B. $FCE2)
    ;

    lowest=blocksize:nextcheck=0
    bytes=0   ; Bleibt "0" wenn packen des Blocks nicht mehr mglich ist!

    If scanvalue.w<256

      If packs>14
        packsize=blocksize:summe=0
        Global Dim founds2.w(65535)
        For z=1 To blocksize
          bits=PeekW(bnk1+z) & $FFFF
          founds2.w(bits)+1
          If founds2.w(bits)>summe:summe=founds2.w(bits):word=bits:EndIf
          If PeekW(bnk1+z+1) & $FFFF=bits:z+1:EndIf
        Next
        If summe>2
          packsize-(summe*2)+summe
          packsize+2+2
          If packsize=<lowest
            lowest=packsize
            bytes=2
            nextcheck=1
            PokeW(scan+1,word)
          EndIf
        EndIf
      Else
        nextcheck=1
      EndIf

      If nextcheck=1 And packs<15
        packsize=blocksize:summe=0:nextcheck=0
        Global Dim scanvals4(1020):Global Dim oldoffset4.w(1020):Global Dim founds4.w(1020)
        For z=1 To blocksize-3
          a=PeekB(bnk1+z+0) & $FF:b=PeekB(bnk1+z+1) & $FF
          c=PeekB(bnk1+z+2) & $FF:d=PeekB(bnk1+z+3) & $FF
          x=PeekL(bnk1+z+0) & $FFFFFFFF
          tst=0
          chksum=a+b+c+d
          If scanvals4(chksum)=x And z>oldoffset4.w(chksum)+3:tst=1:EndIf
          If scanvals4(chksum)=0 And founds4.w(chksum)=0:tst=1:EndIf
          If tst=1
            founds4.w(chksum)+1
            scanvals4(chksum)=x:oldoffset4.w(chksum)=z
            If founds4.w(chksum)>summe:summe=founds4.w(chksum):bits=z:EndIf
          EndIf
        Next
        If summe>1
          packsize-(summe*4)+summe
          packsize+2+4
          If packsize=<lowest
            lowest=packsize
            bytes=4
            nextcheck=1
            langword1=PeekL(bnk1+bits) & $FFFFFFFF
            PokeL(scan+1,langword1)
          EndIf
        EndIf
      EndIf

      If nextcheck=1 And packs<14
        packsize=blocksize:summe=0:nextcheck=0
        Global Dim scanvals8(2040,1):Global Dim oldoffset8.w(2040):Global Dim founds8.w(2040)
        For z=1 To blocksize-7
          a=PeekB(bnk1+z+0) & $FF:b=PeekB(bnk1+z+1) & $FF
          c=PeekB(bnk1+z+2) & $FF:d=PeekB(bnk1+z+3) & $FF
          e=PeekB(bnk1+z+4) & $FF:f=PeekB(bnk1+z+5) & $FF
          g=PeekB(bnk1+z+6) & $FF:h=PeekB(bnk1+z+7) & $FF
          x=PeekL(bnk1+z+0) & $FFFFFFFF:y=PeekL(bnk1+z+4) & $FFFFFFFF
          tst=0
          chksum=a+b+c+d+e+f+g+h
          If scanvals8(chksum,0)=x And scanvals8(chksum,1)=y And z>oldoffset8.w(chksum)+7:tst=1:EndIf
          If scanvals8(chksum,0)=0 And scanvals8(chksum,1)=0 And founds8.w(chksum)=0:tst=1:EndIf
          If tst=1
            founds8.w(chksum)+1
            scanvals8(chksum,0)=x:scanvals8(chksum,1)=y:oldoffset8.w(chksum)=z
            If founds8.w(chksum)>summe:summe=founds8.w(chksum):bits=z:EndIf
          EndIf
        Next
        If summe>1
          packsize-(summe*8)+summe
          packsize+2+8
          If packsize=<lowest
            lowest=packsize
            bytes=8
            nextcheck=1
            langword1=PeekL(bnk1+bits+0) & $FFFFFFFF
            langword2=PeekL(bnk1+bits+4) & $FFFFFFFF
            PokeL(scan+1,langword1)
            PokeL(scan+5,langword2)
          EndIf
        EndIf
      EndIf

      If nextcheck=1 And packs<15
        packsize=blocksize:summe=0:nextcheck=0
        Global Dim scanvals16(4080,3):Global Dim oldoffset16.w(4080):Global Dim founds16.w(4080)
        For z=1 To blocksize-15
          a=PeekB(bnk1+z+0) & $FF:b=PeekB(bnk1+z+1) & $FF
          c=PeekB(bnk1+z+2) & $FF:d=PeekB(bnk1+z+3) & $FF
          e=PeekB(bnk1+z+4) & $FF:f=PeekB(bnk1+z+5) & $FF
          g=PeekB(bnk1+z+6) & $FF:h=PeekB(bnk1+z+7) & $FF
          i=PeekB(bnk1+z+8) & $FF:j=PeekB(bnk1+z+9) & $FF
          k=PeekB(bnk1+z+10) & $FF:l=PeekB(bnk1+z+11) & $FF
          m=PeekB(bnk1+z+12) & $FF:n=PeekB(bnk1+z+13) & $FF
          o=PeekB(bnk1+z+14) & $FF:p=PeekB(bnk1+z+15) & $FF
          x=PeekL(bnk1+z+0) & $FFFFFFFF:y=PeekL(bnk1+z+4) & $FFFFFFFF
          v=PeekL(bnk1+z+8) & $FFFFFFFF:w=PeekL(bnk1+z+12) & $FFFFFFFF
          tst=0
          chksum=a+b+c+d+e+f+g+h+i+j+k+l+m+n+o+p
          If scanvals16(chksum,0)=x And scanvals16(chksum,1)=y And scanvals16(chksum,2)=v And scanvals16(chksum,3)=w And z>oldoffset16.w(chksum)+15:tst=1:EndIf
          If scanvals16(chksum,0)=0 And scanvals16(chksum,1)=0 And scanvals16(chksum,2)=0 And scanvals16(chksum,3)=0 And founds16.w(chksum)=0:tst=1:EndIf
          If tst=1
            founds16.w(chksum)+1
            scanvals16(chksum,0)=x:scanvals16(chksum,1)=y:scanvals16(chksum,2)=v:scanvals16(chksum,3)=w:oldoffset16.w(chksum)=z
            If founds16.w(chksum)>summe:summe=founds16.w(chksum):bits=z:EndIf
          EndIf
        Next
        If summe>1
          packsize-(summe*16)+summe
          packsize+2+16
          If packsize=<lowest
            lowest=packsize
            bytes=16
            nextcheck=1
            langword1=PeekL(bnk1+bits+0) & $FFFFFFFF
            langword2=PeekL(bnk1+bits+4) & $FFFFFFFF
            langword3=PeekL(bnk1+bits+8) & $FFFFFFFF
            langword4=PeekL(bnk1+bits+12) & $FFFFFFFF
            PokeL(scan+1,langword1)
            PokeL(scan+5,langword2)
            PokeL(scan+9,langword3)
            PokeL(scan+13,langword4)
          EndIf
        EndIf
      EndIf

      If nextcheck=1 And packs<4
        packsize=blocksize:summe=0:nextcheck=0
        Global Dim scanvals32(8160,7):Global Dim oldoffset32.w(8160):Global Dim founds32.w(8160)
        For z=1 To blocksize-31
          a=PeekB(bnk1+z+0) & $FF:b=PeekB(bnk1+z+1) & $FF
          c=PeekB(bnk1+z+2) & $FF:d=PeekB(bnk1+z+3) & $FF
          e=PeekB(bnk1+z+4) & $FF:f=PeekB(bnk1+z+5) & $FF
          g=PeekB(bnk1+z+6) & $FF:h=PeekB(bnk1+z+7) & $FF
          i=PeekB(bnk1+z+8) & $FF:j=PeekB(bnk1+z+9) & $FF
          k=PeekB(bnk1+z+10) & $FF:l=PeekB(bnk1+z+11) & $FF
          m=PeekB(bnk1+z+12) & $FF:n=PeekB(bnk1+z+13) & $FF
          o=PeekB(bnk1+z+14) & $FF:p=PeekB(bnk1+z+15) & $FF
          a1=PeekB(bnk1+z+16) & $FF:b1=PeekB(bnk1+z+17) & $FF
          c1=PeekB(bnk1+z+18) & $FF:d1=PeekB(bnk1+z+19) & $FF
          e1=PeekB(bnk1+z+20) & $FF:f1=PeekB(bnk1+z+21) & $FF
          g1=PeekB(bnk1+z+22) & $FF:h1=PeekB(bnk1+z+23) & $FF
          i1=PeekB(bnk1+z+24) & $FF:j1=PeekB(bnk1+z+25) & $FF
          k1=PeekB(bnk1+z+26) & $FF:l1=PeekB(bnk1+z+27) & $FF
          m1=PeekB(bnk1+z+28) & $FF:n1=PeekB(bnk1+z+29) & $FF
          o1=PeekB(bnk1+z+30) & $FF:p1=PeekB(bnk1+z+31) & $FF
          x=PeekL(bnk1+z+0) & $FFFFFFFF:y=PeekL(bnk1+z+4) & $FFFFFFFF
          v=PeekL(bnk1+z+8) & $FFFFFFFF:w=PeekL(bnk1+z+12) & $FFFFFFFF
          v1=PeekL(bnk1+z+16) & $FFFFFFFF:w1=PeekL(bnk1+z+20) & $FFFFFFFF
          v2=PeekL(bnk1+z+24) & $FFFFFFFF:w2=PeekL(bnk1+z+28) & $FFFFFFFF
          tst=0
          chksum=a+b+c+d+e+f+g+h+i+j+k+l+m+n+o+p+a1+b1+c1+d1+e1+f1+g1+h1+i1+j1+k1+l1+m1+n1+o1+p1
          If scanvals32(chksum,0)=x And scanvals32(chksum,1)=y And scanvals32(chksum,2)=v And scanvals32(chksum,3)=w
            If scanvals32(chksum,4)=v1 And scanvals32(chksum,5)=w1 And scanvals32(chksum,6)=v2 And scanvals32(chksum,7)=w2
              If z>oldoffset32.w(chksum)+31:tst=1:EndIf
            EndIf
          EndIf
          If scanvals32(chksum,0)=0 And scanvals32(chksum,1)=0 And scanvals32(chksum,2)=0 And scanvals32(chksum,3)=0
            If scanvals32(chksum,4)=0 And scanvals32(chksum,5)=0 And scanvals32(chksum,6)=0 And scanvals32(chksum,7)=0
              If founds32.w(chksum)=0:tst=1:EndIf
            EndIf
          EndIf
          If tst=1
            founds32.w(chksum)+1:oldoffset32.w(chksum)=z
            scanvals32(chksum,0)=x:scanvals32(chksum,1)=y:scanvals32(chksum,2)=v:scanvals32(chksum,3)=w
            scanvals32(chksum,4)=v1:scanvals32(chksum,5)=w1:scanvals32(chksum,6)=v2:scanvals32(chksum,7)=w2
            If founds32.w(chksum)>summe:summe=founds32.w(chksum):bits=z:EndIf
          EndIf
        Next
        If summe>1
          packsize-(summe*32)+summe
          packsize+2+32
          If packsize=<lowest
            lowest=packsize
            bytes=32
            nextcheck=1
            langword1=PeekL(bnk1+bits+0) & $FFFFFFFF
            langword2=PeekL(bnk1+bits+4) & $FFFFFFFF
            langword3=PeekL(bnk1+bits+8) & $FFFFFFFF
            langword4=PeekL(bnk1+bits+12) & $FFFFFFFF
            langword5=PeekL(bnk1+bits+16) & $FFFFFFFF
            langword6=PeekL(bnk1+bits+20) & $FFFFFFFF
            langword7=PeekL(bnk1+bits+24) & $FFFFFFFF
            langword8=PeekL(bnk1+bits+28) & $FFFFFFFF
            PokeL(scan+1,langword1)
            PokeL(scan+5,langword2)
            PokeL(scan+9,langword3)
            PokeL(scan+13,langword4)
            PokeL(scan+17,langword5)
            PokeL(scan+21,langword6)
            PokeL(scan+25,langword7)
            PokeL(scan+29,langword8)
          EndIf
        EndIf
      EndIf

    EndIf

    ;
    ; Mit dem Packen beginnen... (...wenn Packen des Blocks mglich ist)
    ;

    If bytes>0
      pos=0
      For i=1 To blocksize
        result=0
; ------------------------------------------------------------------------
        If i=<blocksize-bytes+1 ; Falls Pack-Schleifen noch mglich sind
          If PeekW(bnk1+i) & $FFFF=PeekW(scan+1) & $FFFF
            result=CompareMemory(bnk1+i,scan+1,bytes)
            If result ;                Schleife wird gepackt
              i+bytes-1:pos+1
              PokeB(bnk2+pos,scanvalue.w)
            EndIf
          EndIf
        EndIf
; ------------------------------------------------------------------------
        If result=0       ; keine schleife, nur 1 Byte decrunchen
          pos+1
          PokeB(bnk2+pos,PeekB(bnk1+i) & $FF)
        EndIf
; ------------------------------------------------------------------------
      Next

      PokeB(destbnk+destoffset,scanvalue.w)
      destoffset+1
      PokeB(destbnk+destoffset,bytes)
      destoffset+1
      CopyMemory(scan+1,destbnk+destoffset,bytes)
      destoffset+bytes
      CopyMemory(bnk2+1,destbnk+destoffset,pos) ; Gepackten Block Speichern!
      destoffset+pos
    EndIf

    If bytes=0
      PokeB(destbnk+destoffset,0)
      destoffset+1
      CopyMemory(bnk1+1,destbnk+destoffset,blocksize) ; Ungepackten Block Speichern!
      destoffset+blocksize
    EndIf

    If gui=1:While WindowEvent():Wend:EndIf

  Next

  If rest>0
    CopyMemory(origbnk+origoffset,destbnk+destoffset,rest)
    destoffset+rest
  EndIf

  CopyMemory(destbnk,origbnk,destoffset)
  x=origsize
  y=destoffset
  origsize=destoffset
  If y>x Or y<blocksize:Break:EndIf
  u.f=100:u.f=u.f/x:u.f=u.f*y:gain.f=100-u.f
  If packrate=2 And gain.f<10:crunchout+1:EndIf
  If packrate=2 And crunchout=10:Break:EndIf
  If packrate=3 And gain.f<10:crunchout+1:EndIf
  If packrate=3 And crunchout=30:Break:EndIf
  If packrate=4 And gain.f<10:crunchout+1:EndIf
  If packrate=4 And crunchout=60:Break:EndIf

  If gui=1:SetGadgetState(1,crunchout):EndIf

Until packs=255

neu=CreateFile(2,dest$)
WriteLong(2,$00434242)
WriteByte(2,packs)
WriteLong(2,blocksize)
WriteData(2,origbnk,origsize)
CloseFile(2)
FreeMemory(bnk1)
FreeMemory(bnk2)
FreeMemory(scan)
FreeMemory(origbnk)
FreeMemory(destbnk)
x=FileSize(source$)
y=FileSize(dest$)
u.f=100
u.f=u.f/x
u.f=u.f*y
t.f=100-u.f
p=Int(t.f)

If gui=1
  SetGadgetState(1,processbar)
  MessageRequester("Info", "Crunch Process Complete! - Gain: "+Str(p)+"%"+Chr(10)+"",#MB_OK|#MB_ICONINFORMATION)
  CloseWindow(1)
EndIf

ProcedureReturn p

EndProcedure

; jaPBe Version=3.6.5.521
; FoldLines=000B01BB
; Build=0
; Language=0x0000 Language Neutral
; FirstLine=0
; CursorPosition=0
; EnableXP
; ExecutableFormat=Windows
; DontSaveDeclare
; EOF