
; *******************************************************************
; *                                                                 *
; *    PureBasic ExtractFromMemory for BankHolding (Engine) V1.0    *
; * --------------------------------------------------------------- *
; *        Written in 2006 by Harald Wagner (AL90@Lycos.de)         *
; *                                                                 *
; *******************************************************************



; Example:
; --------

;mem.l=ExtractFromMemory(?ArcFile,"MyPacked-File-in-Archive.BBC",1)
;MessageRequester("Info","Unpacked Size = "+Str(MemorySize(mem.l)),#MB_OK|#MB_ICONINFORMATION)
;FreeMemory(mem.l)

;DataSection
;  ArcFile:
;  IncludeBinary "C:\MyArchive.BCA"
;EndDataSection


Procedure.l ExtractFromMemory(bca_memory,pack$,gui)


vers=PeekL(bca_memory) & $FFFFFFFF

If vers<>$00414342 ; Not a Supported BCA-ArchiveFile
  MessageRequester("Error",".BCA ArchiveFile not Found in Memory!",#MB_OK|#MB_ICONERROR)
  ProcedureReturn -1
EndIf

anzfiles=PeekL(bca_memory+4) & $FFFFFFFF
memory=bca_memory+8

For i=1 To anzfiles
  strgsize=PeekL(memory) & $FFFFFFFF
  memory+4
  bbcname$=""
  For x=1 To strgsize
    b=PeekB(memory) & $FF
    memory+1
    bbcname$+Chr(b)
  Next
  l=PeekL(memory) & $FFFFFFFF
  memory+4
  If LCase(bbcname$)=LCase(pack$):Break:EndIf
  memory+l
Next

If LCase(bbcname$)<>LCase(pack$) ; Packfile not found in Archive!
  MessageRequester("Error",".BBC-File not Found in Archive!",#MB_OK|#MB_ICONERROR)
  ProcedureReturn -1
EndIf

z=0
l-9:origsize=l
origoffset=0
destoffset=0
vers=PeekL(memory) & $FFFFFFFF
memory+4
packs=PeekB(memory) & $FF
memory+1
blocksize=PeekL(memory) & $FFFFFFFF
memory+4

If vers<>$00434242 ; Not a Supported Packfile
  MessageRequester("Error","Not a Supported PackFile!",#MB_OK|#MB_ICONERROR)
  ProcedureReturn -1
EndIf

If gui=1
  win=OpenWindow(1,227,113,352,127,"DeCrunching File...Please Wait!",#PB_Window_ScreenCentered) And CreateGadgetList(WindowID(1))
  ProgressBarGadget(1,40,40,270,30,0,packs,#PB_ProgressBar_Smooth)
  SetGadgetState(1,1):SetGadgetState(1,0)
EndIf

bnk1=AllocateMemory(blocksize+1)
bnk2=AllocateMemory(blocksize+1)
scan=AllocateMemory(128)
origbnk=AllocateMemory(l+1000000):memsize1=l+1000000
destbnk=AllocateMemory(l+1000000):memsize2=l+1000000
CopyMemory(memory,origbnk,l) ; Load PakedFile into MEMORY!

Repeat
  If gui=1:While WindowEvent():Wend:EndIf
  z+1
  origoffset=0
  destoffset=0
  l=PeekL(origbnk) & $FFFFFFFF
  If l>memsize1:origbnk=ReAllocateMemory(origbnk,l+1000000):memsize1=l+1000000:EndIf
  If l>memsize2:destbnk=ReAllocateMemory(destbnk,l+1000000):memsize2=l+1000000:EndIf
  origoffset+4
  blocks=l/blocksize:rest=l-(blocks*blocksize)

  ;
  ; Datei entpacken.
  ;

  For loop=1 To blocks
    count=0:pos=0
    scanvalue=PeekB(origbnk+origoffset) & $FF
    origoffset+1

    If scanvalue=0
       CopyMemory(origbnk+origoffset,bnk1+1,blocksize)
       origoffset+blocksize
       CopyMemory(bnk1+1,destbnk+destoffset,blocksize)
       destoffset+blocksize
    Else
      bytes=PeekB(origbnk+origoffset) & $FF
      origoffset+1
      CopyMemory(origbnk+origoffset,scan+1,bytes)
      origoffset+bytes

      Repeat
        b=PeekB(origbnk+origoffset) & $FF
        origoffset+1

        If b=scanvalue
          If einzelsumme>0
            CopyMemory(origbnk+einzelpeek,bnk2+einzelpoke,einzelsumme)
            einzelsumme=0
          EndIf
          CopyMemory(scan+1,bnk2+pos+1,bytes)
          count+bytes
          pos+bytes
        Else
          count+1
          pos+1
          If einzelsumme=0:einzelpoke=pos:einzelpeek=origoffset-1:EndIf
          einzelsumme+1
        EndIf

      Until count=>blocksize

      If einzelsumme>0
        CopyMemory(origbnk+einzelpeek,bnk2+einzelpoke,einzelsumme)
        einzelsumme=0
      EndIf

      CopyMemory(bnk2+1,destbnk+destoffset,pos)
      destoffset+pos
    EndIf
  Next

  If rest>0
    CopyMemory(origbnk+origoffset,destbnk+destoffset,rest)
    origoffset+rest
    destoffset+rest
  EndIf

  CopyMemory(destbnk,origbnk,destoffset)
  origsize=destoffset
  If gui=1:SetGadgetState(1,z):EndIf

Until z=packs

adr=ReAllocateMemory(origbnk,origsize)
FreeMemory(bnk1)
FreeMemory(bnk2)
FreeMemory(scan)
FreeMemory(destbnk)

If gui=1
  SetGadgetState(1,packs)
  MessageRequester("Info", "DecrunchProcess Complete!"+Chr(10)+"",#MB_OK|#MB_ICONINFORMATION)
  CloseWindow(1)
EndIf

ProcedureReturn adr

EndProcedure

; jaPBe Version=3.6.5.521
; FoldLines=001800AE
; Build=0
; Language=0x0000 Language Neutral
; FirstLine=0
; CursorPosition=0
; EnableXP
; ExecutableFormat=Windows
; DontSaveDeclare
; EOF